#define MAXVAL 1000


/*Function Prototypes*/
void a(void);
void b(void);
void c(void);
void d(void);

/*Main function to call each of the functions a through d for our test*/
/*Note that this code can take a long time to execute within the Simulator*/    
int main()
{
	a();
    b();
    c();
    d();
}

/*Function a performs a simple loop of MAX iterations. 
//This function would be expected to make up ~36% of the profile.*/
void a()
{
    int i;
    int j;
    int array[MAXVAL];
    for (j=0; j<MAXVAL; j++)
    {
        for (i=0; i<MAXVAL; i++)
    	{
        	array[i] = i*i;
    	}
    }
    return;
}

/*Function b also performs a simple loop of MAX iterations. 
//This function would also be expected to make up ~36% of the profile.*/
void b()
{
    int i;
    int j;
    int array[MAXVAL];
	for (j=0; j<MAXVAL; j++)
    {
        for (i=0; i<MAXVAL; i++)
    	{
        	array[i] = i*i;
    	}
    }
    return;
}

/*Function c performs half the number of iterations of the loop as a or b. 
//This function would be expected to take up ~18% of the profile.*/
void c()
{
    int i;
    int j;
    int array[MAXVAL/2];
    for (j=0; j<(MAXVAL); j++)
    {
        for (i=0; i<(MAXVAL); i++)
    	{
        	array[i] = i*i;
    	}
    }
    return;
}

/*Function d performs half as many iterations of the loop as c. 
//This function would be expected to take up ~9% of the profile.*/
void d()
{
    int i;
    int j;
    int array[MAXVAL/4];
    for (j=0; j<(MAXVAL); j++)
    {
        for (i=0; i<(MAXVAL); i++)
    	{
        	array[i] = i*i;
    	}
    }
    return;
}
